#pragma once

#include "oaidl.h"

class nsPluginInstance;

class CMidRadioEventListener : public IDispatch
{
public:
  CMidRadioEventListener(nsPluginInstance* aPlugin);
  ~CMidRadioEventListener();

  // IUnknown methods
  STDMETHODIMP QueryInterface(REFIID riid, void ** ppvObj);
  STDMETHODIMP_(ULONG) AddRef();
  STDMETHODIMP_(ULONG) Release();

  // IDispatch methods
  STDMETHODIMP GetTypeInfoCount(UINT *iTInfo);
  STDMETHODIMP GetTypeInfo(UINT iTInfo, LCID lcid, ITypeInfo **ppTInfo);
  STDMETHODIMP GetIDsOfNames(REFIID riid, OLECHAR **rgszNames, UINT cNames, LCID lcid, DISPID *rgDispId);
  STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

private:
  int m_refCount;
  nsPluginInstance* mPlugin;
};
